/*****************************************************
This program was produced by the
CodeWizardAVR V1.24.4 Standard
Automatic Program Generator
 Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com
e-mail:office@hpinfotech.com

Project : 
Version : 
Date    : 1/2/2002
Author  : Mohammad                        
Company : Griffin                         
Comments: 


Chip type           : ATmega8L
Program type        : Application
Clock frequency     : 4.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
 #include <delay.h>
// Alphanumeric LCD Module functions
#asm
   .equ __lcd_port=0x18 ;PORTB
#endasm
#include <lcd.h>

// Declare your global variables here
char keypad(void);
char password_check(void);
void new_password(void);
#pragma warn-
char eeprom password[5];
#pragma warn+
char password_att[5], password_temp[5],key=0,c,i=0,accept=0;
void main(void)
{
// Declare your local variables here

// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0x00;

// Port D initialization
// Func7=In Func6=Out Func5=Out Func4=Out Func3=Out Func2=In Func1=In Func0=In 
// State7=T State6=0 State5=0 State4=0 State3=0 State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x78;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: Timer 0 Stopped
TCCR0=0x00;
TCNT0=0x00;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: Timer 1 Stopped
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Discon.
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x00;
TCCR1B=0x00;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x00;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// LCD module initialization
lcd_init(16);

PORTD=255;
while (1)
      {      
      lcd_clear();
      lcd_putsf("Enter password *");
      lcd_gotoxy(0,1);
      lcd_putsf("Change password#");
      PORTD.3=1;
      PORTD.4=1;
      PORTD.5=1;
      PORTD.6=0;  
      if(PIND.2==0)
        {
                delay_ms(10);
                if(PIND.2==0)
                 {
                       new_password();
                 }
        }                           
       if(PIND.0==0)
        {
                delay_ms(10);
                if(PIND.0==0)
                 {
                       password_check();
                 }
        }                           
      };
      }   

////////////////
////////////////
char password_check()
{       
        int temp=0; 
        lcd_clear();
        lcd_putsf("Enter password:");  
        lcd_gotoxy(0,1); 
        for (i=0;i<4;i++)       
        {
                password_att[i]=keypad();
                lcd_putchar('*');
        }    
        for (i=0;i<4;i++)       
        {
                password_temp[i]=password[i];
        }     
       for (i=0;i<4;i++)       
        {   
            if (password_att[i]==password_temp[i])
                temp++;
        } 
        if(temp<4)
        {
                lcd_clear();
                lcd_putsf("invalid password!");
                temp=0;
                delay_ms(500);
                accept=0;
        }
        else if(temp==4)  
         {      
                lcd_clear();
                lcd_putsf("Password accepted!");
                delay_ms(500);
                accept=1; 
          }
       
       return accept;
       
} 

////////////////
////////////////
void new_password(void)
{     
        int temp;
        lable:
        temp=0;
        lcd_clear(); 
        lcd_putsf("Enter old pass:");
        lcd_gotoxy(0,1); 
        for (i=0;i<4;i++)       
        {
                password_att[i]=keypad();
                lcd_putchar('*');
        }
        for (i=0;i<4;i++)       
        {
                password_temp[i]=password[i];
        }     
       for (i=0;i<4;i++)       
        {   
            if (password_att[i]==password_temp[i])  
                temp++;
        } 
        if(temp>3)  
         {      
                lcd_clear();
                lcd_putsf("Enter new pass:"); 
                lcd_gotoxy(0,1); 
                for (i=0;i<4;i++)       
                {      
                   password[i]=keypad();
                   lcd_putchar('*');
                }
          } 
         else if(temp<4)
        {
                lcd_clear();
                lcd_putsf("invalid password!");
                temp=0;
                delay_ms(500);
                goto lable;
        }
} 
////////////////
////////////////
char keypad(void)
{       
        char key_press=1;
        while(key_press) 
        {
        //////
        PORTD.3=0;
        PORTD.4=1;
        PORTD.5=1;
        PORTD.6=1; 
        if(PIND.0==0)
        {
                delay_ms(10);
                if(PIND.0==0)
                {
                        key_press=0;
                        key=1;
                 }
        }        
        if(PIND.1==0)
        {
                delay_ms(10);
                if(PIND.1==0)
                 {
                        key_press=0;
                        key=2;
                 }
        }
        if(PIND.2==0)
        {
                delay_ms(10);
                if(PIND.2==0)
                 {
                        key_press=0;
                        key=3;
                 }
        }  
        
        /////
        PORTD.3=1;
        PORTD.4=0;
        PORTD.5=1;
        PORTD.6=1; 
        if(PIND.0==0)
        {       
                key_press=0;
                delay_ms(10);
                if(PIND.0==0)
                 {
                        key_press=0;
                        key=4;
                 }
        }
        if(PIND.1==0)
        {       
                key_press=0;
                delay_ms(10);
                if(PIND.1==0)
                {
                        key_press=0;
                        key=5;
                 }
        }
        if(PIND.2==0)
        {                
                key_press=0;
                delay_ms(10);
                if(PIND.2==0)
                {
                        key_press=0;
                        key=6;
                 }
        } 
        
        //////
        PORTD.3=1;
        PORTD.4=1;
        PORTD.5=0;
        PORTD.6=1; 
        if(PIND.0==0)
        {           
                key_press=0;
                delay_ms(10);
                if(PIND.0==0)
                {
                        key_press=0;
                        key=7;
                 }
        }
        if(PIND.1==0)
        {           
                key_press=0;
                delay_ms(10);
                if(PIND.1==0)
                {
                        key_press=0;
                        key=8;
                 }
        }
        if(PIND.2==0)
        {         
                key_press=0;
                delay_ms(10);
                if(PIND.2==0)
                {
                        key_press=0;
                        key=9;
                 }
        }                           
        
        //////
        PORTD.3=1;
        PORTD.4=1;
        PORTD.5=1;
        PORTD.6=0; 
        
        if(PIND.1==0)
        {
                key_press=0;
                delay_ms(10);
                if(PIND.1==0)
                {
                        key_press=0;
                        key=0;
                 }
        }
         
        
        }   
        delay_ms(100);
        return key;  
}
